.nolist
include \masm32\include\masm32rt.inc

	LOOP_COUNT  EQU 1000000/10        ; 1M iterations per timing result
	SleepTime = 32*2
	seeresult = 0	; 1=show the string once
	testmode=0		; 1=show some tests

.686
; .k3d
.xmm
include \masm32\macros\timers.asm

; [url=http://www.masm32.com/board/index.php?topic=1589.msg12747#msg12747]original source[/url] (stillslow.zip posted by Lingo)

Main	proto
SzCpy10	proto :DWORD,:DWORD
szCopyMMX	proto :DWORD,:DWORD
SzCpy11	proto :DWORD,:DWORD
szCopyMMX1	proto :DWORD,:DWORD
szCopyXMM	proto :DWORD,:DWORD
szCopyXMM2	proto :DWORD,:DWORD
simplecopy	proto :DWORD,:DWORD
simplecopyNW	proto :DWORD,:DWORD
MbCopy	proto :DWORD,:DWORD
MbCopyD	proto :DWORD,:DWORD

setsrc MACRO arg
  CurrentSrc equ <offset arg>
  print chr$(13,10,10,"Source len=")
  print str$(len(CurrentSrc))
ENDM

copytest MACRO arg
LOCAL tmp$, src, dest, showit
  showit = 2
  ifidn <arg>, <szCopyXMM2>
	showit = 0
  elseifidn <arg>, <SzCpy11>
	showit = 0
  elseifidn <arg>, <szCopyMMX1>
	showit = 0
  elseifidn <arg>, <lstrcpy>
	showit = 0
  elseifidn <arg>, <szCopyMMX>
	showit = 1
  elseifidn <arg>, <SzCpy10>
	showit = 1
  endif
  if showit ge 2	; ge 1 to show the functioning MMX versions
  src equ <CurrentSrc>
  dest equ <offset String2>
  ifidn <szCopy>, <arg>
	src equ dest
	dest equ <CurrentSrc>
  endif
  print chr$(13, 10)
  invoke memfill, offset String2, 512+4, 0
  counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke arg, dest, src
  counter_end
  print str$(eax), 9
  tmp$ CATSTR <print chr$(" clocks for >, <arg>, <")>
  tmp$
  ifidn <arg>, <szCopyMMX>
	print " ", 9, "mmx, trashes FPU"
  endif
  ifidn <arg>, <SzCpy10>
	print " ", 9, "mmx, trashes FPU"
  endif
  ifidn <arg>, <szCopyMMX1>
	print " ", 9, "mmx, trashes FPU"
  endif
;  ifidn <arg>, <szCopyXMM>
;	print " ", 9, "x"
;  endif
  push esi
  push edi
  mov esi, src
  mov edi, dest
  mov ecx, len(esi)
  mov eax, [esi+ecx-2]
  mov edx, [edi+ecx-2]
  .if eax!=edx
;  	push eax
;  	print hex$(edx)
;  	print "/"
;  	pop eax
;  	print hex$(eax), 13,10
	print ", result NOT CORRECT"
;	print esi, 13,10
;	print edi
  .endif
  pop edi
  pop esi
  if seeresult eq 2
	print chr$(13, 10, "Result= ", 9)
	print offset String2
  endif
  invoke Sleep, SleepTime
  endif
ENDM

testbounds MACRO arg2, arg1
  invoke memfill, offset arg2, sizeof arg1, 0
  if testmode eq 1
  	print chr$(13, 10, "Testing Mark's code, szCopyMMX1:")
	invoke szCopyMMX1, offset arg2, offset arg1
  elseif testmode eq 2
  	print chr$(13, 10, "Testing Lingo's code, SzCpy11:")
	invoke SzCpy11, offset arg2, offset arg1
  else
  	print chr$(13, 10, "Testing JJ's code:")
	invoke szCopyMMX, offset arg2, offset arg1
  endif
  print chr$(13,10, "Source=")
  print offset arg2
  print chr$(13,10, "  Dest=")
  print offset arg1
ENDM

.data
CanSSE2	dd -1
txHi	db "Hi", 0
c15	db "B23456789012345", 0
c16	db "C234567890123456", 0
c17	db "D2345678901234567", 0

d15	db 15 dup ("b"), "x"
d16	db 16 dup ("c"), "x"
d17	db 17 dup ("d"), "x"

align 16

spoil1	db 1, 2, 3		; badly aligned source

String1	DB  "Smple Strng 0134 679 BCD", 13, 10, " ABbCcDdEFfGgHhIiJjKkLlMMNnOoP"
	DB "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play", 13, 10
	DB  "Smple Strng 0134 679 BCD", 13, 10, " ABbCcDdEFfGgHhIiJjKkLlMMNnOoP"
	DB "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play", 13, 10
	
	DB 0,0
	db "RUBBISH for testing the boundaries", 13, 10, 0
align 16

spoil2	db 1, 2, 3, 4, 5, 7, 8, 9, 10, 11		; badly aligned destination (removing does NOT cause a crash)

String2     DB  16*32 dup(0)
                db 0, "rubbish for testing the boundaries", 13, 10, 10
                db 100 dup(0)	; see what happens if you comment this line

SzSzCpy10	DB  "SzCpy10        - > Lingo ->        MMX: ",0
sszCopyMMX	DB  "szCopyMMX   -> Mark Larson   ->    MMX: ",0
SzSzCpy11	DB   "SzCpy11  -- > Lingo ->  MMX   ->  Fast: ",0
sszCopyMMX1	DB  "szCopyMMX1-> Mark Larson -> MMX-> Fast: ",0

.code

Start:
	invoke SetConsoleOutputCP, 1252
	if testmode
		testmode=0
		testbounds d15, c15	; test the 16-bytes boundary
		testbounds d16, c16
		testbounds d17, c17
		print chr$(13,10)
		testmode=1
		testbounds d15, c15	; test the 16-bytes boundary
		testbounds d16, c16
		testbounds d17, c17
		print chr$(13,10)
		testmode=2
		testbounds d15, c15	; test the 16-bytes boundary
		testbounds d16, c16
		testbounds d17, c17
	endif

  Invoke Main
.listall

  print chr$(13,10,9, " --------------",13,10)
;  MsgBox 0, str$(eax), offset txHi, MB_OK
  MsgBox 0, str$(eax), chr$("Hello"), MB_OK		; GARBAGE instead of Hello

.nolist
  exit

  if 0	; make some result tests
 ; invoke MbCopy, offset String2, chr$("Test1234")
;  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("Test123")
  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("Test12")
  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("Test1")
  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("Test")
  print offset String2, 13,10
 ; invoke MbCopy, offset String2, chr$("")
;  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("")
  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("")
  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("")
  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("")
  print offset String2, 13,10
  invoke MbCopy, offset String2, chr$("")
  print offset String2, 13,10
  print chr$(13,10,9, " --------------",13,10)
  getkey
  Invoke ExitProcess, 0
  endif

Main Proc
    print chr$(13, 10, 10, " Timing routines by MichaelW from MASM32 forums, http://www.masmforum.com/",13,10)
    ; mov   eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")

	print chr$(13,10," 512-byte string copy timing results:",13,10,13,10)
	; print " len of source string = "
	; print str$(len(offset String1)), 13, 10
	print " alignment: offset src="
	print str$(offset String1)
	print ", dest="
	print str$(offset String2), 13, 10

    	 print " len of szCopyXMM: ", 9
    	 mov eax, offset jj1
    	 sub eax, szCopyXMM
    	 print str$(eax), 13, 10

    	 print " len of simplecopy: ", 9
    	 mov eax, offset jj3
    	 sub eax, simplecopy
    	 print str$(eax), 13, 10

    	 print " len of simplecopyNW: ", 9
    	 mov eax, offset jj4
    	 sub eax, simplecopyNW
    	 print str$(eax), 13, 10

 	 print " len of MbCopy:      ", 9
    	 mov eax, offset jj2
    	 sub eax, MbCopy
    	 print str$(eax), 13, 10, 10

    top = 0		; change order
   
    if seeresult
	invoke szCopyXMM, offset String2, offset String1
	print chr$(13, 10, "Source: ", 13, 10)
	print offset String1
	print chr$(13, 10, "Destination: ", 13, 10)
	print offset String2, 13, 10
    endif
if 1
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest simplecopyNW
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD
endif

  mov edx, offset String1
  mov word ptr [edx+511], 0
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest simplecopyNW
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

  mov edx, offset String1
  mov word ptr [edx+128], 0
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest simplecopyNW
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

if 0
  mov edx, offset String1
  mov word ptr [edx+127], 0
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

  mov edx, offset String1
  mov word ptr [edx+63], 0	; starting from 63...
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

  mov edx, offset String1
  mov word ptr [edx+55], 0	; 63-8
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

  mov edx, offset String1
  mov word ptr [edx+48], 0	; 55-7
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

  mov edx, offset String1
  mov word ptr [edx+42], 0	; 48-6
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

  mov edx, offset String1
  mov word ptr [edx+37], 0	; 42-5
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD
endif

  mov edx, offset String1
  mov word ptr [edx+15], 0
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest simplecopyNW
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD

  mov edx, offset String1
  mov word ptr [edx+7], 0
  setsrc String1
  copytest szCopyXMM
  copytest szCopyXMM2
  copytest szCopyMMX
  copytest SzCpy11
  copytest szCopyMMX1
  copytest SzCpy10
  copytest simplecopy
  copytest simplecopyNW
  copytest szCopy
  copytest lstrcpy
  copytest crt_strcpy
  copytest MbCopy
  copytest MbCopyD
  copytest lstrcpy
  print chr$(13, 10, "--- OK ---", 13, 10)
  ret
Main EndP

OPTION PROLOGUE:NONE   ; It  is SzCpy10  MMX by Lingo
OPTION EPILOGUE:NONE
comment * MMX by Lingo*
align 16
@@:
	movq		MM1,	[ecx+eax]
    movq		[edx+eax-8], MM0
@@2:
    movq		MM0,	[ecx+eax]					
	pcmpeqb	MM1,	MM7
	packsswb	MM1,	MM1
	movd		ebx,		MM1
	test			bl,		bl
	lea			eax,		[eax+8]
	je				@B
@@:									
	movzx	    ebx, byte ptr [ecx+eax-8]		
	add			eax, 1
	test			bl, bl
	mov			[edx+eax-9], bl
	jnz			@B
	mov			ebx, [esp+2*4]						
	ret			2*4
align 16
SzCpy10   proc    SzDest:DWORD, SzSource:DWORD
				mov		ecx, [esp+2*4]		; ecx = source
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
 				pxor		MM7,MM7
				movq	MM1, [ecx]
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@2
 SzCpy10 endp


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16

COMMENT ^
ml v614
004019C0              ? 0FEFC9                      pxor mm1, mm1
004019C3              > 0F1006                      movups xmm0, dqword ptr [esi]
004019C6              . 0F74C8                      pcmpeqb mm1, mm0
004019C9              . 0FD7C9                      pmovmskb ecx, mm1
004019CC              . 85C9                        test ecx, ecx
004019CE              .75 0B                       jne short SzCpy.004019DB
004019D0              . 0F1107                      movups dqword ptr [edi], xmm0

ml v9
004019C8              ? 660FEFC9                    pxor xmm1, xmm1
004019CC              . 0F1006                      movups xmm0, dqword ptr [esi]
004019CF              ? 660F74C8                    pcmpeqb xmm1, xmm0
004019D3              . 660FD7C9                    pmovmskb ecx, xmm1
004019D7              ? 85C9                        test ecx, ecx
004019D9              .75 0B                       jne short SzCpy.004019E6
004019DB              > 0F1107                      movups dqword ptr [edi], xmm0

JWasm
004019C8              ? 660FEFC9                    pxor xmm1, xmm1
004019CC              . 0F1006                      movups xmm0, dqword ptr [esi]
004019CF              ? 660F74C8                    pcmpeqb xmm1, xmm0
004019D3              . 660FD7C9                    pmovmskb ecx, xmm1
004019D7              ? 85C9                        test ecx, ecx
004019D9              .75 0B                       jne short SzCpy.004019E6
004019DB              > 0F1107                      movups dqword ptr [edi], xmm0
^

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
simplecopy proc dest:DWORD, src:DWORD	; [url=http://www.masm32.com/board/index.php?topic=10830.msg79446#msg79446]Sinsi[/url]
    push ebx
    mov ecx, [esp+8]
    mov edx, [esp+12]
    sub ebx, ebx
@@:
    mov al, [edx+ebx]
    mov [ecx+ebx], al
    inc ebx
    test al, al
    jnz @B
    pop ebx
    ret 8
simplecopy endp
jj3:

align 16
simplecopyNW proc dest:DWORD, src:DWORD	; [url=http://www.masm32.com/board/index.php?topic=10830.msg79446#msg79446]Sinsi[/url]
	mov edx, [esp+4]
	mov ecx, [esp+8]
	sub edx,ecx
@@:	mov al,[ecx]
	mov [ecx+edx],al
	inc ecx
	test al,al
	jnz @b
	ret 8
simplecopyNW endp
jj4:

comment * inspired by "MMX  Fast" by Mark Larson *
align 16	; seems to have NO influence
szCopyXMM proc dest:DWORD, src:DWORD ; JJ
  saveregs=1
  ChkFPU=0
  if ChkFPU
	call LoadFPU
  endif
  if saveregs
	push esi
	mov esi, [esp+8+4]
	mov edx, [esp+4+4]
	; push ecx					; preserve another valuable register?
  else
	mov esi, [esp+8]
	mov edx, [esp+4]
  endif
  if 0
	cmp CanSSE2, -1 		 	; this test costs about 3 cycles
	je NonSSE2
  endif
  pxor xmm1, xmm1

@@:
  ; ----------------------------------------------------
  movups xmm0, [esi]
  pcmpeqb xmm1, xmm0
  pmovmskb ecx, xmm1			; Move Byte Mask To Integer - a fantastic instruction!
  test ecx, ecx
  jnz @F
  add esi, 16
  movups [edx], xmm0
  add edx, 16
  ; ----------------------------------------------------
  movups xmm0, [esi] 
  pcmpeqb xmm1, xmm0
  pmovmskb ecx, xmm1			; Move Byte Mask To Integer
  test ecx, ecx 
  jnz @F
  add esi, 16
  movups [edx], xmm0
  add edx, 16
  ; ----------------------------------------------------
  jmp @B

; no align 4	; ------------------------ tail cleanup ------------------------
NonSSE2:
@@:
	if 0
	.if edi==12345				; debug flag
		invoke memfill, offset String2, 512, "DDDD"
		invoke memfill, offset String1, 512, "SSSS"
		mov eax, offset String1
		mov edx, offset String2
;		 int 3
		invoke crt_strcpy, offset String2, chr$("aaaaabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz123")
		xor edi, edi				; clear flag
	.endif
	endif
  ; mov eax, [esi]				; get next 4 bytes
  lodsd						; 4 cycles faster for short strings
  lea ecx, [eax-01010101h]		; subtract 1 from each byte
  test ecx, 80808080h			; same as and ecx, 80808080h
  jnz @F						; jump if zero byte

NotZero:
  mov [edx], eax				; store a dword
  add edx, 4					; inc destination
  ; add esi, 4					; edx, esi some cycles faster than esi, edx on Core2
  jmp @B

@@:	not eax					; invert all bytes - for the full story, see
	and ecx, eax			; http://www.masm32.com/board/index.php?topic=1589.msg12333#msg12333 
	not eax					; and each byte with inversion, then restore bytes
	test ecx, 80808080h		; bytes=80h for null, otherwise 0
	jz NotZero
	sub esi, 4				; correct lodsd
@@:
  mov cl, [esi]					; copy non-aligned bytes
  inc esi
  mov [edx], cl
  inc edx
  test cl, cl
  jnz @B

  mov eax, edx		; a stringcat routine might need this one
  if saveregs
	; pop ecx		; save ecx?
	pop esi
  endif
ret 8		; cleanup
szCopyXMM endp
jj1:

align 16	; seems to have NO influence
szCopyXMM2 proc dest:DWORD, src:DWORD
  saveregs=1
  ChkFPU=0
  if ChkFPU
	call LoadFPU
  endif
  if 0
	cmp CanSSE2, 0  	; test CanSSE2, 1 is longer
	je @
  endif
  if saveregs
	push esi
	mov esi, [esp+8+4]
	mov edx, [esp+4+4]
	; push ecx	; preserve another valuable register?
  else
	mov esi, [esp+8]
	mov edx, [esp+4]
  endif
  pxor xmm1, xmm1
@@:
  movups xmm0, [esi] 
  pcmpeqb xmm1, xmm0
  pmovmskb ecx, xmm1	; Move Byte Mask To Integer - a fantastic instruction!
  test ecx,ecx 
  jnz @F
  movups [edx], xmm0
  add esi, 16
  add edx, 16
  jmp @B

align 4	; ------------------------ tail cleanup ------------------------
@@:
  mov eax, [esi]			; get next 4 bytes
  ; mov ecx, ebx			; 21% slower than lea on P4,
  ; sub ecx, mcMagic		; tested with rep 800
  lea ecx, [eax-01010101h]	; subtract 1 from each byte
  test ecx, 80808080h		; same as and ecx, 80808080h
  jnz @F					; jump if zero byte

NotZero:
  mov [edx], eax			; store a dword
  add esi, 4				; eax, edx 1% faster than edx, eax on P4
  add edx, 4				; inc destination
  jmp @B

@@:	not eax					; invert all bytes - for the full story, see
	and ecx, eax			; http://www.masm32.com/board/index.php?topic=1589.msg12333#msg12333 
	not eax					; and each byte with inversion, then restore bytes
	test ecx, 80808080h		; bytes=80h for null, otherwise 0
	jz NotZero

align 4					; align 16 is somewhat slower
@@:
  mov cl, [esi]				; copy non-aligned bytes
  mov [edx], cl
  add esi, 1				; add is 16% faster then inc on P4
  add edx, 1
  test cl, cl
  jnz @B

  mov eax, edx		; a stringcat routine might need this one
  if saveregs
	; pop ecx		; save ecx?
	pop esi
  endif
ret 8		; cleanup
szCopyXMM2 endp


OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE   ; It  is SzCpy11  MMX  Fast by Lingo
OPTION EPILOGUE:NONE
comment * MMX by Lingo*
align 16
@@:
	movq		MM1,	[ecx+eax]
    movq		[edx+eax-8], MM0
@@21:
    movq		MM0,	[ecx+eax]					
	pcmpeqb	MM1,	MM7
	packsswb	MM1,	MM1
	movd		ebx,		MM1
	test			ebx,		ebx
	lea			eax,		[eax+8]
	je				@B
	mov			ebx, [esp+2*4]						
	ret			2*4
align 16
SzCpy11   proc    SzDest:DWORD, SzSource:DWORD
;int 3
;				finit			trashes the FPU
;				mov eax, 12345678
;				push eax
;				fild dword ptr [esp]
				mov		ecx, [esp+2*4]		; ecx = source
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
 				pxor		MM7,MM7
				movq	MM1, [ecx]
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@21
 SzCpy11 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef


OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
comment * MMX by Mark Larson *

align 16
szCopyMMX proc near dst_str:DWORD, src_str:DWORD
push esi	; added JJ
   mov eax,[esp+8+4]
   mov esi,[esp+4+4]

align 16
qword_copy:
   pxor MM1,MM1
   movq MM0,[eax] 
   pcmpeqb MM1,MM0
   add eax,8 
   pmovmskb ecx,MM1
   or ecx,ecx 
   jnz finish_rest
   movq [esi],MM0
   add esi,8
   jmp qword_copy

finish_rest:
;ret 8

;if 0
bsf ecx,ecx
cmp ecx,7
je do_7
cmp ecx,6
je do_6
cmp ecx,5
je do_5
cmp ecx,4
je do_4
cmp ecx,3
je do_3
cmp ecx,2
je do_2

do_7:
mov ecx,[eax-8]
mov edx,[eax+4-8] ;really copy 8 bytes to include the 0
mov [esi],ecx
mov [esi+4],edx
pop esi	; added JJ
ret 8 ; ret

do_6:
mov ecx,[eax-8]
movzx edx,word ptr[eax+4-8]
mov [esi],ecx
mov [esi+4],dx
mov byte ptr [esi+6],0
pop esi	; added JJ
ret 8 ; ret

do_5:
mov ecx,[eax-8]
movzx edx,byte ptr[eax+4-8]
mov [esi],ecx
mov [esi+4],dl
mov byte ptr [esi+5],0
pop esi	; added JJ
ret 8 ; ret


do_4:
mov ecx,[eax-8]
mov [esi],ecx
mov byte ptr [esi+4],0
pop esi	; added JJ
ret 8 ; ret


do_3:
movzx ecx,word ptr[eax-8]
movzx edx,byte ptr[eax+2-8]
mov [esi],cx
mov [esi+2],dl
mov byte ptr [esi+3],0
pop esi	; added JJ
ret 8 ; ret

do_2:
movzx ecx,word ptr[eax-8]
mov byte ptr [esi+2],0
pop esi	; added JJ
ret 8 ; ret

;cmp ecx,1
;je do_1
movzx ecx,byte ptr [eax-8]
mov [esi],cl
pop esi		; added JJ
ret 8 ; ret

szCopyMMX endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef       

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
comment * MMX  Fast by Mark Larson *

align 16
szCopyMMX1 proc near dst_str:DWORD, src_str:DWORD
push esi	; added JJ
   mov eax,[esp+8+4]
   mov esi,[esp+4+4]

align 16
qword_copy1:
   pxor MM1,MM1
   movq MM0,[eax] 
   pcmpeqb MM1,MM0
   add eax,8 
   pmovmskb ecx,MM1
   or ecx,ecx 
   jnz finish_rest1
   movq [esi],MM0
   add esi,8
   jmp qword_copy1
finish_rest1:
pop esi	; added JJ
ret 8

szCopyMMX1 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef       

LoadFPU proc						; test: load all 8 FPU regs
		if ChkFPU
			finit
		endif
		xor eax, eax
		ifndef f2sP10
			.data?
			f2sP10	dd ?
			.code
		endif
		mov ecx, offset f2sP10	; clear the first table entry to
		mov [ecx], eax			; signal it has to be created again
		mov ecx, 8
@@:		push ecx
		fild dword ptr [esp]
		pop ecx
		dec ecx
		jne @B
;		pushad
;		print chr$(13, 10, "Init", 13,10)
;		popad
		ret
LoadFPU endp

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
; align 16 ; has no effect
; nop
; nop
; nop
NoAlign=	0	; clearly not a good option, but you can test it here
DestAlign=	0	; choose if you want to align the source or the destination
MbCopy proc dest:DWORD, src:DWORD
	push edi
	mov edi, [esp+8]
	mov ecx, [esp+12]
	if NoAlign
		jmp mbcMain 			; neither source nor dest alignment??
	endif
	if DestAlign
	  test edi, 3					; edi=destination address
	else
	  test ecx, 3					; ecx=source address
	endif
	je mbcMain					; dword aligned
@@:	mov al, byte ptr [ecx]		; a byte from src
	inc ecx
	test al, al
	mov byte ptr [edi], al		; does not change the flag, so we can say bye if al was zero
	je mbcBye
	inc edi
	if DestAlign
	  test edi, 3					; edi=destination address
	else
	  test ecx, 3					; ecx=source address
	endif
	jne @B
	jmp mbcMain
	; align 16 no good, costs cycles

@@:				; ------------ innermost loop ------------
	mov [edi], eax
	add edi, 4
mbcMain:	
	mov eax, 07EFEFEFFh
	mov edx, [ecx]
	add eax, edx
	xor edx, eax
	xor edx, 0FFFFFFFFh
	mov eax, [ecx]
	add ecx, 4
	test edx, 81010100h
	je @B			; ------------ innermost loop ------------

	test al, al
	je mbc1
	test ah, ah
	je mbc2
	test eax, 00FF0000h
	je mbc3

mbc4:	
	mov [edi], eax
	jmp mbcBye
mbc3:	
	mov byte ptr [edi+2], 0
mbc2:	
	mov word ptr [edi], ax
mbc1:
	mov byte ptr [edi], al
mbcBye:	
	mov edx, [esp+8]	; return start of buffer
	pop edi
	ret 8
MbCopy endp
jj2:

DestAlign=1	; choose if you want to align the source or the destination
MbCopyD proc dest:DWORD, src:DWORD
	push edi
	mov edi, [esp+8]
	mov ecx, [esp+12]
	if NoAlign
		jmp mbcMain 			; neither source nor dest alignment??
	endif
	if DestAlign
	  test edi, 3					; edi=destination address
	else
	  test ecx, 3					; ecx=source address
	endif
	je mbcMain					; dword aligned
@@:
	mov al, byte ptr [ecx]		; a byte from src
	inc ecx
	test al, al
	mov byte ptr [edi], al		; does not change the flag, so we can say bye if al was zero
	je mbcBye
	inc edi
	if DestAlign
	  test edi, 3					; edi=destination address
	else
	  test ecx, 3					; ecx=source address
	endif
	jne @B
	jmp mbcMain
	; align 16 no good, costs cycles

@@:				; ------------ innermost loop ------------
	mov [edi], eax
	add edi, 4
mbcMain:	
	mov eax, 07EFEFEFFh
	mov edx, [ecx]
	add eax, edx
	xor edx, eax
	xor edx, 0FFFFFFFFh
	mov eax, [ecx]
	add ecx, 4
	test edx, 81010100h
	je @B			; ------------ innermost loop ------------

	test al, al
	je mbc1
	test ah, ah
	je mbc2
	test eax, 00FF0000h
	je mbc3

mbc4:	
	mov [edi], eax
	jmp mbcBye
mbc3:	
	mov byte ptr [edi+2], 0
mbc2:	
	mov word ptr [edi], ax
mbc1:
	mov byte ptr [edi], al
mbcBye:	
	mov edx, [esp+8]	; return start of buffer
	pop edi
	ret 8
MbCopyD endp

End Start
OPT_Assembler	JWasm
OPT_Tmp2Asm	1
OPT_Res	0
OPT_BatL	chcp 1252
OPT_Src	[url=http://www.experts-exchange.com/Programming/Languages/CPP/Q_20973108.html]EE[/url]
OPT_DelLst	0
